from __future__ import annotations

from collections.abc import Mapping
from typing import Any, TypeVar

from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..types import UNSET, Unset

T = TypeVar("T", bound="PkgRoutesMiscCreateDemoRequest")


@_attrs_define
class PkgRoutesMiscCreateDemoRequest:
    """
    Attributes:
        campaign_id (str | Unset):
        color (str | Unset):
        demo (str | Unset):
        logo (str | Unset):
    """

    campaign_id: str | Unset = UNSET
    color: str | Unset = UNSET
    demo: str | Unset = UNSET
    logo: str | Unset = UNSET
    additional_properties: dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> dict[str, Any]:
        campaign_id = self.campaign_id

        color = self.color

        demo = self.demo

        logo = self.logo

        field_dict: dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if campaign_id is not UNSET:
            field_dict["campaign_id"] = campaign_id
        if color is not UNSET:
            field_dict["color"] = color
        if demo is not UNSET:
            field_dict["demo"] = demo
        if logo is not UNSET:
            field_dict["logo"] = logo

        return field_dict

    @classmethod
    def from_dict(cls: type[T], src_dict: Mapping[str, Any]) -> T:
        d = dict(src_dict)
        campaign_id = d.pop("campaign_id", UNSET)

        color = d.pop("color", UNSET)

        demo = d.pop("demo", UNSET)

        logo = d.pop("logo", UNSET)

        pkg_routes_misc_create_demo_request = cls(
            campaign_id=campaign_id,
            color=color,
            demo=demo,
            logo=logo,
        )

        pkg_routes_misc_create_demo_request.additional_properties = d
        return pkg_routes_misc_create_demo_request

    @property
    def additional_keys(self) -> list[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
